# coding: utf-8

"""
    VMware Aria Automation Assembler Blueprint API

    A multi-cloud Blueprint API for VMware Aria Automation Services  This page describes the RESTful APIs for Blueprint. The APIs facilitate CRUD operations on the various resources and entities used throughout Blueprint (Blueprints, Blueprint Terraform Integrations , PropertyGroups , etc.) and allow operations on them (creating a Blueprint, creating a Property group, etc.).  The APIs that list collections of resources  also support OData like implementation. Below query params can be used across Blueprint entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/blueprint/api/blueprints?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/blueprint/api/blueprints?$top=10&$skip=2```   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from idem_vra.client.vra_blueprint_lib.api_client import ApiClient


class BlueprintTerraformIntegrationsApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_blueprint_from_mapping_using_post(self, body, **kwargs):  # noqa: E501
        """Creates a blueprint from a Terraform blueprint configuration (obtained from /create-blueprint-mapping).  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_from_mapping_using_post(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerraformCreateblueprintfrommappingBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_blueprint_from_mapping_using_post_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_blueprint_from_mapping_using_post_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def create_blueprint_from_mapping_using_post_with_http_info(self, body, **kwargs):  # noqa: E501
        """Creates a blueprint from a Terraform blueprint configuration (obtained from /create-blueprint-mapping).  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_from_mapping_using_post_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerraformCreateblueprintfrommappingBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: ApiBlueprintsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_blueprint_from_mapping_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_blueprint_from_mapping_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/create-blueprint-from-mapping', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ApiBlueprintsBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_blueprint_mapping_using_post(self, body, **kwargs):  # noqa: E501
        """Retrieves and parses the specified Terraform configuration file(s) and returns relevant information for blueprint construction.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_mapping_using_post(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerraformCreateblueprintmappingBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_blueprint_mapping_using_post_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_blueprint_mapping_using_post_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def create_blueprint_mapping_using_post_with_http_info(self, body, **kwargs):  # noqa: E501
        """Retrieves and parses the specified Terraform configuration file(s) and returns relevant information for blueprint construction.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_blueprint_mapping_using_post_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerraformCreateblueprintmappingBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse2008
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_blueprint_mapping_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_blueprint_mapping_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/create-blueprint-mapping', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2008',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def create_terraform_version_using_post(self, body, **kwargs):  # noqa: E501
        """Creates a version  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_terraform_version_using_post(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerraformVersionsBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: TerraformVersionsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_terraform_version_using_post_with_http_info(body, **kwargs)  # noqa: E501
        else:
            (data) = self.create_terraform_version_using_post_with_http_info(body, **kwargs)  # noqa: E501
            return data

    def create_terraform_version_using_post_with_http_info(self, body, **kwargs):  # noqa: E501
        """Creates a version  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_terraform_version_using_post_with_http_info(body, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param TerraformVersionsBody body: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: TerraformVersionsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_terraform_version_using_post" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `create_terraform_version_using_post`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/versions', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TerraformVersionsBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_terraform_version_using_delete(self, version_id, **kwargs):  # noqa: E501
        """Deletes a terraform version  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_terraform_version_using_delete(version_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_terraform_version_using_delete_with_http_info(version_id, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_terraform_version_using_delete_with_http_info(version_id, **kwargs)  # noqa: E501
            return data

    def delete_terraform_version_using_delete_with_http_info(self, version_id, **kwargs):  # noqa: E501
        """Deletes a terraform version  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_terraform_version_using_delete_with_http_info(version_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_terraform_version_using_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version_id' is set
        if ('version_id' not in params or
                params['version_id'] is None):
            raise ValueError("Missing the required parameter `version_id` when calling `delete_terraform_version_using_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/versions/{versionId}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_configuration_source_tree_using_get(self, configuration_source_id, **kwargs):  # noqa: E501
        """Shows directories of the configuration source repository that correspond to Terraform configurations.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_configuration_source_tree_using_get(configuration_source_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str configuration_source_id: The ID of the configuration source to inspect. (required)
        :param str commit_id: The commit ID corresponding to the version of the configuration source.
        :param str path: A file path prefix. The prefix is interpreted in the context of the configuration source's path prefix. Results will only include directories under this path.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20016
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_configuration_source_tree_using_get_with_http_info(configuration_source_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_configuration_source_tree_using_get_with_http_info(configuration_source_id, **kwargs)  # noqa: E501
            return data

    def get_configuration_source_tree_using_get_with_http_info(self, configuration_source_id, **kwargs):  # noqa: E501
        """Shows directories of the configuration source repository that correspond to Terraform configurations.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_configuration_source_tree_using_get_with_http_info(configuration_source_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str configuration_source_id: The ID of the configuration source to inspect. (required)
        :param str commit_id: The commit ID corresponding to the version of the configuration source.
        :param str path: A file path prefix. The prefix is interpreted in the context of the configuration source's path prefix. Results will only include directories under this path.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20016
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['configuration_source_id', 'commit_id', 'path', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_configuration_source_tree_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'configuration_source_id' is set
        if ('configuration_source_id' not in params or
                params['configuration_source_id'] is None):
            raise ValueError("Missing the required parameter `configuration_source_id` when calling `get_configuration_source_tree_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'configuration_source_id' in params:
            query_params.append(('configurationSourceId', params['configuration_source_id']))  # noqa: E501
        if 'commit_id' in params:
            query_params.append(('commitId', params['commit_id']))  # noqa: E501
        if 'path' in params:
            query_params.append(('path', params['path']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/get-configuration-source-tree', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20016',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_terraform_configuration_source_commit_list_using_get(self, configuration_source_id, **kwargs):  # noqa: E501
        """Returns a paginated list of commits for a specified configuration source.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_terraform_configuration_source_commit_list_using_get(configuration_source_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str configuration_source_id: A Configuration Source ID. (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20017
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_terraform_configuration_source_commit_list_using_get_with_http_info(configuration_source_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_terraform_configuration_source_commit_list_using_get_with_http_info(configuration_source_id, **kwargs)  # noqa: E501
            return data

    def get_terraform_configuration_source_commit_list_using_get_with_http_info(self, configuration_source_id, **kwargs):  # noqa: E501
        """Returns a paginated list of commits for a specified configuration source.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_terraform_configuration_source_commit_list_using_get_with_http_info(configuration_source_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str configuration_source_id: A Configuration Source ID. (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20017
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['configuration_source_id', 'page', 'size', 'sort', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_terraform_configuration_source_commit_list_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'configuration_source_id' is set
        if ('configuration_source_id' not in params or
                params['configuration_source_id'] is None):
            raise ValueError("Missing the required parameter `configuration_source_id` when calling `get_terraform_configuration_source_commit_list_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'configuration_source_id' in params:
            query_params.append(('configurationSourceId', params['configuration_source_id']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/get-configuration-source-commits', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20017',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_terraform_configuration_sources_using_get(self, projects, **kwargs):  # noqa: E501
        """Returns a paginated list of configuration sources configured as storage for Terraform configurations.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_terraform_configuration_sources_using_get(projects, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] projects: A comma-separated list of project IDs. Results will be filtered so only configuration sources accessible from one or more of these projects will be returned. (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str search: A search parameter to search based on configuration source name or repository.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20015
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_terraform_configuration_sources_using_get_with_http_info(projects, **kwargs)  # noqa: E501
        else:
            (data) = self.get_terraform_configuration_sources_using_get_with_http_info(projects, **kwargs)  # noqa: E501
            return data

    def get_terraform_configuration_sources_using_get_with_http_info(self, projects, **kwargs):  # noqa: E501
        """Returns a paginated list of configuration sources configured as storage for Terraform configurations.  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_terraform_configuration_sources_using_get_with_http_info(projects, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param list[str] projects: A comma-separated list of project IDs. Results will be filtered so only configuration sources accessible from one or more of these projects will be returned. (required)
        :param int page: Zero-based page index (0..N)
        :param int size: The size of the page to be returned
        :param list[str] sort: Sorting criteria in the format: property,(asc|desc). Default sort order is ascending. Multiple sort criteria are supported.
        :param str search: A search parameter to search based on configuration source name or repository.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse20015
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['projects', 'page', 'size', 'sort', 'search', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_terraform_configuration_sources_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'projects' is set
        if ('projects' not in params or
                params['projects'] is None):
            raise ValueError("Missing the required parameter `projects` when calling `get_terraform_configuration_sources_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'size' in params:
            query_params.append(('size', params['size']))  # noqa: E501
        if 'sort' in params:
            query_params.append(('sort', params['sort']))  # noqa: E501
            collection_formats['sort'] = 'multi'  # noqa: E501
        if 'projects' in params:
            query_params.append(('projects', params['projects']))  # noqa: E501
            collection_formats['projects'] = 'multi'  # noqa: E501
        if 'search' in params:
            query_params.append(('search', params['search']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/get-configuration-sources', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20015',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_terraform_version_using_get(self, version_id, **kwargs):  # noqa: E501
        """Returns Terraform Version details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_terraform_version_using_get(version_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: TerraformVersionsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_terraform_version_using_get_with_http_info(version_id, **kwargs)  # noqa: E501
        else:
            (data) = self.get_terraform_version_using_get_with_http_info(version_id, **kwargs)  # noqa: E501
            return data

    def get_terraform_version_using_get_with_http_info(self, version_id, **kwargs):  # noqa: E501
        """Returns Terraform Version details  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_terraform_version_using_get_with_http_info(version_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str version_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: TerraformVersionsBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['version_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_terraform_version_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'version_id' is set
        if ('version_id' not in params or
                params['version_id'] is None):
            raise ValueError("Missing the required parameter `version_id` when calling `get_terraform_version_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/versions/{versionId}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='TerraformVersionsBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_terraform_versions_using_get(self, pageable, **kwargs):  # noqa: E501
        """Lists terraform versions  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_terraform_versions_using_get(pageable, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Pageable pageable: (required)
        :param bool only_enabled: Include only enabled versions
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is descending on updatedAt. Sorting is supported on fields createdAt, updatedAt, createdBy, updatedBy, version.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_terraform_versions_using_get_with_http_info(pageable, **kwargs)  # noqa: E501
        else:
            (data) = self.list_terraform_versions_using_get_with_http_info(pageable, **kwargs)  # noqa: E501
            return data

    def list_terraform_versions_using_get_with_http_info(self, pageable, **kwargs):  # noqa: E501
        """Lists terraform versions  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_terraform_versions_using_get_with_http_info(pageable, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Pageable pageable: (required)
        :param bool only_enabled: Include only enabled versions
        :param int top: Number of records you want
        :param int skip: Number of records you want to skip
        :param str orderby: Sorting criteria in the format: property (asc|desc). Default sort order is descending on updatedAt. Sorting is supported on fields createdAt, updatedAt, createdBy, updatedBy, version.
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: InlineResponse2007
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['pageable', 'only_enabled', 'top', 'skip', 'orderby', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_terraform_versions_using_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'pageable' is set
        if ('pageable' not in params or
                params['pageable'] is None):
            raise ValueError("Missing the required parameter `pageable` when calling `list_terraform_versions_using_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'pageable' in params:
            query_params.append(('pageable', params['pageable']))  # noqa: E501
        if 'only_enabled' in params:
            query_params.append(('onlyEnabled', params['only_enabled']))  # noqa: E501
        if 'top' in params:
            query_params.append(('$top', params['top']))  # noqa: E501
        if 'skip' in params:
            query_params.append(('$skip', params['skip']))  # noqa: E501
        if 'orderby' in params:
            query_params.append(('$orderby', params['orderby']))  # noqa: E501
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/versions', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse2007',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def update_terraform_version_using_patch(self, body, version_id, **kwargs):  # noqa: E501
        """Updates a terraform version  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_terraform_version_using_patch(body, version_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param VersionsVersionIdBody body: (required)
        :param str version_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: VersionsVersionIdBody
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.update_terraform_version_using_patch_with_http_info(body, version_id, **kwargs)  # noqa: E501
        else:
            (data) = self.update_terraform_version_using_patch_with_http_info(body, version_id, **kwargs)  # noqa: E501
            return data

    def update_terraform_version_using_patch_with_http_info(self, body, version_id, **kwargs):  # noqa: E501
        """Updates a terraform version  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.update_terraform_version_using_patch_with_http_info(body, version_id, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param VersionsVersionIdBody body: (required)
        :param str version_id: (required)
        :param str api_version: The version of the API in yyyy-MM-dd format (UTC). For versioning information please refer to /blueprint/api/about
        :return: VersionsVersionIdBody
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body', 'version_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_terraform_version_using_patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_terraform_version_using_patch`")  # noqa: E501
        # verify the required parameter 'version_id' is set
        if ('version_id' not in params or
                params['version_id'] is None):
            raise ValueError("Missing the required parameter `version_id` when calling `update_terraform_version_using_patch`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'version_id' in params:
            path_params['versionId'] = params['version_id']  # noqa: E501

        query_params = []
        if 'api_version' in params:
            query_params.append(('apiVersion', params['api_version']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['Bearer']  # noqa: E501

        return self.api_client.call_api(
            '/blueprint/api/blueprint-integrations/terraform/versions/{versionId}', 'PATCH',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='VersionsVersionIdBody',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
